"""
This is the sunxi.fsimage module which contains a class responsible for
helping create a filesystem image of a chroot.

Author:    Niall Walsh
Copyright: Copyright (C) 2013 Niall Walsh <niallwalsh@users.berlios.de>
License:   GPL-2
"""

import fll.misc

class FsCompError(Exception):
    pass

class FsComp(object):
    taropt = dict( gz='-z', bz='-j', xz='-J' )
    excludes = [ 'etc/.*lock', 'etc/*-', 'etc/adjtime', 'etc/apt/*~', 'etc/blkid.tab', 'etc/console-setup/*.gz', 'etc/localtime', 'etc/lvm/archive', 'etc/lvm/backup', 'etc/lvm/cache', 'etc/timezone', 'etc/ssh/ssh_host_*key*', 'etc/udev/rules.d/70-persistent-*.rules', 'etc/X11/xorg.conf', 'lib/init/rw/*', 'media/*', 'media/.*', 'mnt/*', 'proc/*', 'root/*', 'root/.*', 'run/*', 'sys/*', 'tmp/*', 'tmp/.*', 'usr/bin/qemu-*-static', 'var/cache/apt/*.bin', 'var/cache/apt-show-versions/*', 'var/cache/debconf/*-old', 'var/lib/alsa/asound.state', 'var/lib/apt/extended_states', 'var/lib/apt/lists/*_dists_*', '/var/lib/dbus/machine-id', 'var/lib/dpkg/*-old', 'var/run/*' ]
    def __init__(self, chroot=None,config={}):
        self.chroot=chroot
        self.config=config
    def tar(self):
        if ('tar' in self.config):
            config=self.config['tar']
	else:
	    return True
        cmd = ['tar', '-c']
        if ('compressor' in config):
            if (self.taropt.has_key(config['compressor'])):
                cmd.append("%s" % self.taropt[config['compressor']])
        cmd.append('-f')
        if ('file' in config):
            cmd.append(config['file'])
        else:
            filename='%s.%s' % (self.chroot.rootdir,'tar')
            if ('compressor' in config):
                filename='%s.%s' % (filename, config['compressor'])
            cmd.append(filename)
        if 'exclude' in config:
            excludes = config['exclude']
        elif 'exclude' in self.config:
            excludes = self.config['exclude']
        xfile=self.chroot.chroot_path('tmp/tar.exclude')
        fh = open(xfile, 'w')
        excludes=self.excludes
        excludes.append('tar.exclude')
        print >>fh, "\n".join(excludes) + "\n"
        fh.close()
        cmd.append('-X')
        cmd.append(xfile)
        cmd.append('-C')
        cmd.append(self.chroot.rootdir)
        cmd.append('.')
        fll.misc.cmd(cmd)
    pass
